<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, inject, ref } from 'vue';
import Dropdown from '@/components/general/Dropdown.vue';
import ShareChatModal from '@/components/chat/ShareChatModal.vue';
import ChatExportModal from "@/components/chat/ChatExportModal.vue";
import { useChatStore } from '@/stores/chat';
import { storeToRefs } from 'pinia';
import { useI18n } from 'vue-i18n';
import Modal from '@/components/general/Modal.vue';

const configuration = inject<any>('configuration');
const { t } = useI18n();
const $t = t;

const props = defineProps<{
    label: string,
    uuid: string,
    avatar?: string,
    icon: string,
    isActive?: boolean,
    expireDays?: number,
    type: string,
    sharedUntil?: string
}>();

const chatStore = useChatStore();
const { state, uuid, loadMessage, loadImage } = storeToRefs(chatStore);

const emits = defineEmits<{
    (e: 'click', uuid: string): void
}>();

const handleShowRenameModal = () => {
    uuid.value = props.uuid;
    state.value = 'CHAT_EDIT';
};

const showShareModal = ref(false);
const handleShowShareModal = () => {
    showShareModal.value = true;
};
const handleCloseShareModal = () => {
    showShareModal.value = false;
};

const showExportModal = ref(false);
const handleShowExportModal = () => {
    showExportModal.value = true;
};

const handleCloseExportModal = () => {
    showExportModal.value = false;
};

const handleCopyModal = () => {
    uuid.value = props.uuid;
    state.value = props.type === 'chat' ? 'CHAT_COPY' : props.type === 'image' ? 'IMAGE_COPY' : 'PERSON_CHAT_COPY';
};

const handleShowDeleteModal = () => {
    uuid.value = props.uuid;
    state.value = 'CHAT_DELETE';
};

const handleClick = () => {
    if(loadMessage.value || loadImage.value){
        isChangeWarningModalOpen.value = true;
    }else{
        emits('click', props.uuid);
    }
};

const isChangeWarningModalOpen = ref(false);
const handleSubmitConfirmWarning = ()=>{
    handleCancelConfirmWarning();
    emits('click', props.uuid);
};

const handleCancelConfirmWarning = ()=>{
    isChangeWarningModalOpen.value = false;
};

const getAvatarPath = computed(() => {
    if (props.avatar)
        return configuration.apiServer + props.avatar;
});

const getExpireDaysLabel = computed(() => {
    if (props.expireDays !== undefined)
        return props.expireDays === 0 ? $t('ai.overview.item.expire.tooltip.today') : props.expireDays > 1 ? $t('ai.overview.item.expire.tooltip.pl', [props.expireDays]) : $t('ai.overview.item.expire.tooltip.sg', [props.expireDays]);
});



</script>
<template>
    <button class="w-full flex flex-row gap-2 hover:bg-gray-200 justify-between pr-2 rounded-md outline-0 focus:outline-1 focus-within:outline-1" role="button"
        :class="isActive ? 'bg-gray-200' : ''" @keyup.enter="handleClick">
        <div class="w-full flex flex-row">
            <Tooltip :tooltip="getExpireDaysLabel" v-if="expireDays !== undefined">
                <i class="ri-time-line text-red-500 cursor-pointer pl-2 -mr-1 leading-6"></i>
            </Tooltip>
            <button
                class="flex flex-row h-6 px-2 py-0.5 gap-1 rounded-md w-full outline-0 focus:outline-0 focus-within:outline-0"
                @click="handleClick">
                <i :class="`ri-${icon}-line`" v-if="!avatar"></i>
                <img class="h-4 mt-0.5 rounded-full" :src="getAvatarPath" v-else />
                <p class="text-left text-ellipsis line-clamp-1 min-h-5 max-h-5 align-middle break-all">{{ label }}</p>
            </button>
        </div>
        <div v-if="sharedUntil"><Tooltip :tooltip="$t('ai.overview.item.share.tooltip', [sharedUntil])"><i class="ri-share-line text-gray-500"></i></Tooltip></div>
        <div class="size-6">
            <Dropdown width="w-full">
                <template #button>
                    <Tooltip :tooltip="$t('ai.overview.item.additionalFunctions.label')"><button
                            class="rounded-full hover:bg-gray-100 size-6 outline-0 focus:outline-0 focus-within:outline-0"><strong><i
                                    class="ri-more-line"></i></strong></button></Tooltip>
                </template>
                <div>
                    <button class="flex flex-row gap-2 w-full px-2 py-1 hover:bg-gray-100 rounded-md text-left"
                        @click="handleShowRenameModal"><i class="ri-pencil-line text-blue-500"></i>{{
                            $t('ai.overview.item.additionalFunctions.rename') }}</button>
                    <button class="flex flex-row gap-2 w-full px-2 py-1 hover:bg-gray-100 rounded-md text-left"
                        @click="handleCopyModal"><i class="ri-file-copy-line text-cyan-500"></i>{{
                            $t('contentPage.copyLabel')
                        }}</button>
                    <button class="flex flex-row gap-2 w-full px-2 py-1 hover:bg-gray-100 rounded-md text-left"
                        @click="handleShowShareModal"><i class="ri-share-line text-orange-500"></i>{{
                            $t('ai.overview.item.additionalFunctions.share') }}</button>
                    <button class="flex flex-row gap-2 w-full px-2 py-1 hover:bg-gray-100 rounded-md text-left"
                        @click="handleShowExportModal"><i class="ri-file-line text-fuchsia-700"></i>{{
                            $t('ai.overview.item.additionalFunctions.export') }}</button>
                    <button class="flex flex-row gap-2 w-full px-2 py-1 hover:bg-gray-100 rounded-md text-left"
                        @click="handleShowDeleteModal"><i class="ri-delete-bin-line text-red-700"></i>{{
                            $t('ai.overview.item.additionalFunctions.delete') }}</button>
                </div>
            </Dropdown>
        </div>
    </button>
    <ShareChatModal :uuid="props.uuid" @close="handleCloseShareModal" :type="type" v-if="showShareModal"
        :title="props.label" />
    <ChatExportModal :uuid="props.uuid" @close="handleCloseExportModal" v-if="showExportModal" />
    <Modal v-if="isChangeWarningModalOpen" :header="$t('general.errors.warning')" 
        :text="$t('ai.general.warning.changeChat')" 
        :labelSubmit="$t('general.buttons.next')" :labelCancel="$t('general.buttons.cancel')" 
        @submit="handleSubmitConfirmWarning" @cancel="handleCancelConfirmWarning"/>
</template>